/*
 * Copyright (C) 2003      Martyn Russell <ginxd@btopenworld.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/* 
 * $RCSfile: common.h,v $
 *
 * $Author: ginxd $
 * $Date: 2003/11/09 20:42:54 $
 * 
 * $Revision: 1.42 $
 *
 */

#ifdef __cplusplus
extern "C" {
#if 0
}
#endif
#endif

#ifndef __common_h
#define __common_h

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <glib.h>

/***********************************************************************
 * i21n
 ***********************************************************************/

/* #ifndef WIN32 */

#ifdef HAVE_GETTEXT

#include <libintl.h>

#define _(String) gettext (String)
#define gettext_noop(String) String
/* #define N_(String) gettext_noop (String) */

#else

#define _(String) (String)
#define N_(String) (String)

#endif

/***********************************************************************
 * IMAGE FILENAMES
 ***********************************************************************/

/*
 * Root directories
 */


#define GCONF_PATH "/apps/gnome-jabber"


/* paths */
#ifdef WIN32
#  define PATH_LOG "logs"
#  define PATH_HISTORY "history"
#  define PATH_USERDIR PACKAGE
#  define PATH_DATA ""
#  define PATH_PIXMAPS ""
#else
#  define PATH_LOG "logs"
#  define PATH_HISTORY "history"
#  define PATH_GNOME_CONFIG ".gnome2"
#  define PATH_USERDIR PATH_GNOME_CONFIG G_DIR_SEPARATOR_S PACKAGE
#  define PATH_DATA DATADIR G_DIR_SEPARATOR_S PACKAGE G_DIR_SEPARATOR_S
#  define PATH_PIXMAPS DATADIR G_DIR_SEPARATOR_S PACKAGE G_DIR_SEPARATOR_S
#endif

/* gui */
#define FILE_GLADE PACKAGE ".glade"

/* configuration */
#define FILE_CONFIG PACKAGE ".config"

/* logging */
#define FILE_LOG PACKAGE ".log"

/* images */
#define FILE_IMAGE_EXT ".png"

/* history */
#define FILE_CSS PACKAGE ".css"

/* jabber software foundation */
#define FILE_JSF PATH_PIXMAPS "gj_jsf" FILE_IMAGE_EXT


/* absolute file/dir's */
#define PATH_FULL_HISTORY G_DIR_SEPARATOR_S PATH_USERDIR G_DIR_SEPARATOR_S PATH_HISTORY
#define FILE_FULL_CONFIG G_DIR_SEPARATOR_S PATH_USERDIR G_DIR_SEPARATOR_S FILE_CONFIG
#define FILE_FULL_CSS PATH_DATA == "" ? FILE_CSS : PATH_DATA G_DIR_SEPARATOR_S FILE_CSS
#define FILE_FULL_GLADE PATH_DATA == "" ? FILE_GLADE : PATH_DATA G_DIR_SEPARATOR_S FILE_GLADE

/***********************************************************************
 * ROSTER CONSTANTS        
 ***********************************************************************/

#define ROSTER_GROUP_OFFLINE _("Offline")
#define ROSTER_GROUP_NOT_ON_ROSTER _("Not On Roster")
#define ROSTER_GROUP_RESOURCE _("Resources")
#define ROSTER_GROUP_SUBSCRIBING _("Subscribing")
#define ROSTER_GROUP_AGENTS _("Agents")

#define ROSTER_CONTACT_PRESENCE_DETAILS_FORMAT "%s\n<span font_family=\"Sans\" size=\"7000\" weight=\"ultralight\">%s</span>"

/* #define ROSTER_CONTACT_PRESENCE_DETAILS_FORMAT "%s\n<span size=\"7000\" font_family=\"Sans\" weight=\"ultralight\" foreground=\"#909090\">%s</span>"  */

/***********************************************************************
 * EMOTE ICONS        
 ***********************************************************************/

typedef enum {
  
    emote_biggrin = 1,
    emote_confused,
    emote_cool,
    emote_eek,
    emote_frown,
    emote_mad,
    emote_redface,
    emote_rolleyes,
    emote_smile,
    emote_tongue,
    emote_wink,
    emote_null
    
} emote_icon;

#define EMOTE_BIGGRIN ":D"
#define EMOTE_CONFUSED ":s"
#define EMOTE_COOL "(h)"
#define EMOTE_EEK ":O"
#define EMOTE_FROWN ":("
#define EMOTE_MAD ":@"
#define EMOTE_REDFACE ":$"
#define EMOTE_ROLLEYES "8)"
#define EMOTE_SMILE ":)"
#define EMOTE_TONGUE ":P"
#define EMOTE_WINK ";)"



#endif

#ifdef __cplusplus
}
#endif
