/*
 * Copyright (C) 2003      Martyn Russell <ginxd@btopenworld.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/* 
 * $RCSfile: gj_config_handler.h,v $
 *
 * $Author: ginxd $
 * $Date: 2003/10/05 16:11:11 $
 * 
 * $Revision: 1.5 $
 *
 */

#ifdef __cplusplus
extern "C" {
#if 0
}
#endif
#endif

#ifndef __gj_config_handler_h
#define __gj_config_handler_h

#include <glib.h>

typedef struct
{
  gchar *key;
  gchar *value;

} configLine;

typedef struct
{
  gchar *name;
  GList *lines;

} configSection;

typedef struct
{
  GList *sections;

} configFile;

configFile *gj_config_handler_new(void);
configFile *gj_config_handler_open_file(gchar *filename);
gboolean gj_config_handler_write_file(configFile *cfg, gchar *filename);
void gj_config_handler_free(configFile *cfg);
configFile *gj_config_handler_open_default_file(void);
gboolean gj_config_handler_write_default_file(configFile *cfg);

gboolean gj_config_handler_read_string(configFile *cfg, gchar *section, gchar *key, gchar ** value);
gboolean gj_config_handler_read_int(configFile *cfg, gchar *section, gchar *key, gint *value);
gboolean gj_config_handler_read_int8(configFile *cfg, gchar *section, gchar *key, gint8 *value);
gboolean gj_config_handler_read_boolean(configFile *cfg, gchar *section, gchar *key, gboolean *value);
gboolean gj_config_handler_read_float(configFile *cfg, gchar *section, gchar *key, gfloat *value);
gboolean gj_config_handler_read_double(configFile *cfg, gchar *section, gchar *key, gdouble *value);

void gj_config_handler_write_string(configFile *cfg, gchar *section, gchar *key, gchar *value);
void gj_config_handler_write_int(configFile *cfg, gchar *section, gchar *key, gint value);
void gj_config_handler_write_int8(configFile *cfg, gchar *section, gchar *key, gint8 value);
void gj_config_handler_write_boolean(configFile *cfg, gchar *section, gchar *key, gboolean value);
void gj_config_handler_write_float(configFile *cfg, gchar *section, gchar *key, gfloat value);
void gj_config_handler_write_double(configFile *cfg, gchar *section, gchar *key, gdouble value);

void gj_config_handler_remove_key(configFile *cfg, gchar *section, gchar *key);

#ifdef __cplusplus
};
#endif

#endif
