/*
 * Copyright (C) 2003      Martyn Russell <ginxd@btopenworld.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/* 
 * $RCSfile: gj_gtk_first_time_run.c,v $
 *
 * $Author: ginxd $
 * $Date: 2003/10/05 16:11:12 $
 * 
 * $Revision: 1.12 $
 *
 */

#ifdef __cplusplus
extern "C" {
#if 0
}
#endif
#endif

#include <string.h>
#include <stdlib.h>

#include <gtk/gtk.h>
#include <glade/glade.h>

#include <unistd.h>

#include "common.h"

#include "gj_main.h"
#include "gj_roster.h"
#include "gj_agents.h"
#include "gj_iq_requests.h"

#include "gj_gtk_add_contact.h"
#include "gj_gtk_roster.h"
#include "gj_gtk_support.h"
#include "gj_gtk_connection_settings.h"


struct 
{
  GtkWidget *window;
  
} ctlFTR;


/* gui callbacks */
static void on_first_time_run_response(GtkDialog *dialog, gint response, gpointer user_data);

/*
 * code
 */
gboolean gj_gtk_ftr_load()
{
  GladeXML *xml = NULL;

  if(ctlFTR.window != NULL)
  {
      gtk_window_present(GTK_WINDOW(ctlFTR.window));
      return TRUE;
  }

  xml = gj_gtk_glade_get_file(gnome_jabber_get_glade_file(),
			      "first_time_run",
			      NULL,
			      "first_time_run", &ctlFTR.window,
			      NULL);

  gj_gtk_glade_connect(xml,
		       NULL,
		       "first_time_run", "response", on_first_time_run_response,
		       NULL);

  if(!xml) return FALSE;
  g_object_unref(xml);

  gdk_window_set_decorations (GDK_WINDOW(ctlFTR.window->window), 
			      GDK_DECOR_BORDER | GDK_DECOR_TITLE);

  return TRUE;
}

gboolean gj_gtk_ftr_unload()
{
  if(ctlFTR.window == NULL) 
    return TRUE;
  
  
  gtk_widget_destroy(GTK_WIDGET(ctlFTR.window));
  ctlFTR.window = NULL;
  
  return TRUE;
}

static void on_first_time_run_response(GtkDialog *dialog, gint response, gpointer user_data)
{
  switch(response) 
    {
    case GTK_RESPONSE_NONE:
    case GTK_RESPONSE_DELETE_EVENT:
    case GTK_RESPONSE_CANCEL: 
    case GTK_RESPONSE_CLOSE:
      gj_gtk_ftr_unload();
      gj_gtk_cs_load();
      break;
      
    default:
      g_message("on_first_time_run_response: response:%d not handled", response);
      break;
    }
}

#ifdef __cplusplus
}
#endif
