/*
 * Copyright (C) 2003      Martyn Russell <ginxd@btopenworld.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/* 
 * $RCSfile: gj_gtk_progress.h,v $
 *
 * $Author: ginxd $
 * $Date: 2003/10/05 16:11:13 $
 * 
 * $Revision: 1.3 $
 *
 */

#ifdef __cplusplus
extern "C" {
#if 0
}
#endif
#endif

#ifndef __gj_gtk_progress_h_
#define __gj_gtk_progress_h_

#include <gtk/gtk.h>


typedef struct t_prg *Prg;
typedef void (*PrgCb)(gboolean cancelled, void *userdata);

gboolean gj_gtk_progress_init();
gboolean gj_gtk_progress_term();

/* item functions */
Prg gj_gtk_progress_start(gboolean modal,
			  GtkWindow *transient_window,
			  PrgCb cb, 
			  void *userdata, 
			  const gchar *primary, 
			  const gchar *secondary, 
			  ...);

void gj_gtk_progress_stop(Prg p);

#endif

#ifdef __cplusplus
}
#endif

