/*
 * Copyright (C) 2003      Martyn Russell <ginxd@btopenworld.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/* 
 * $RCSfile: gj_me.h,v $
 *
 * $Author: ginxd $
 * $Date: 2003/10/08 11:22:07 $
 * 
 * $Revision: 1.11 $
 *
 */

#ifdef __cplusplus
extern "C" {
#if 0
}
#endif
#endif

#ifndef __gj_me_h
#define __gj_me_h

#include <glib.h>

#include "gj_presence.h"

typedef void (*GjMeUptimeCallback)(gdouble seconds);

/* get members */
gboolean gj_me_get_is_connected();
const gchar *gj_me_get_connected_host();
guint gj_me_get_connected_port();

const gchar *gj_me_get_connected_jid();
gchar *gj_me_get_connected_jid_without_resource();

gboolean gj_me_get_is_auto_away();
GjPresenceShow gj_me_get_auto_away_presence_show();

GjPresenceType gj_me_get_presence_type();
GjPresenceShow gj_me_get_presence_show();
const gchar *gj_me_get_presence_status();
gint8 gj_me_get_presence_priority();

gdouble gj_me_get_uptime();

/* set members */
void gj_me_set_is_connected(const gboolean is_connected);
gboolean gj_me_set_connected_host(const gchar *host);
gboolean gj_me_set_connected_port(const guint port);
gboolean gj_me_set_connected_jid(const gchar *jid);

void gj_me_set_is_auto_away(const gboolean is_auto_away);
void gj_me_set_auto_away_presence_show(const GjPresenceShow show);

void gj_me_set_presence_type(const GjPresenceType type);
void gj_me_set_presence_show(const GjPresenceShow show);
void gj_me_set_presence_status(const gchar *status);
void gj_me_set_presence_priority(const gint8 priority);

void gj_me_set_uptime_start();
void gj_me_set_uptime_stop();
void gj_me_set_uptime_restart();

gboolean gj_me_set_uptime_cb(GjMeUptimeCallback cb);
void gj_me_set_uptime_cb_to_null();


#endif

#ifdef __cplusplus
}
#endif
