/*
 * Copyright (C) 2003      Martyn Russell <ginxd@btopenworld.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/*
 * $RCSfile: gj_support.h,v $
 *
 * $Author: ginxd $
 * $Date: 2003/10/07 06:59:06 $
 *
 * $Revision: 1.10 $
 *
 */

#ifdef __cplusplus
extern "C" {
#if 0
}
#endif
#endif

#ifndef __gj_h
#define __gj_h

#include <time.h>

typedef enum t_uriType {
  uriTypeUnknown = 1,
  uriTypeURL,
  uriTypeHost,

  uriTypeEnd
} uriType;

int gj_get_unique_id();

const char *gj_get_time_zone();

const char *gj_get_timestamp();
const char *gj_get_timestamp_long();
const char *gj_get_timestamp_from_timet(time_t now);

const char *gj_get_datestamp();
const char *gj_get_datestamp_long();
const char *gj_get_datestamp_from_timet(time_t now);

const char *gj_get_time_and_date_from_timet(time_t now);

const char *gj_get_timestamp_full();
const char *gj_get_timestamp_nice();
const char *gj_get_timestamp_nice_from_timet(time_t now);

gboolean gj_find_in_str(const gchar *needle, const gchar *haystack);
gchar *gj_find_in_str_and_remove(const gchar *needle, const gchar *haystack);
gchar *gj_find_in_str_and_replace(const gchar *needle, const gchar *haystack, const gchar *replacement);

gboolean gj_is_word_separator(gchar c);
uriType gj_is_uri(const gchar *word);

char *gj_get_sha_by_session_id_and_password(const gchar *session_id, const gchar *password);

gboolean gj_create_dir(const gchar *dir);


#endif

#ifdef __cplusplus
}
#endif
